# ------------------------------------------------------------------------------
#   J1: ~/_plugins/simple_search_filter.rb
#   Liquid filter's to be used with JekyllSimple Search
#
#   Product/Info:
#   http://jekyll.one
#
#   Copyright (C) 2016 Juergen Adams
#
#   Licensed under the Creative Commons Attribution 3.0 Unported License.
#   For details, see http://creativecommons.org/licenses/by/3.0/.
#
# ------------------------------------------------------------------------------
#  $LastChangedDate: 2016-12-04 19:37:21 +0100 (So, 04 Dez 2016) $
#  $LastChangedRevision: 13 $
#  $LastChangedBy: jadams $
# ------------------------------------------------------------------------------

module Jekyll
  module CharFilter
    def remove_chars(input)
      input.gsub! '\\','&#92;'
      input.gsub! /\t/, '    '
      input.strip_control_and_extended_characters
    end
  end
end

Liquid::Template.register_filter(Jekyll::CharFilter)

class String
  def strip_control_and_extended_characters()
    chars.each_with_object("") do |char, str|
      str << char if char.ascii_only? and char.ord.between?(32,126)
    end
  end
end